#ifndef hash_h
#define hash_h

typedef struct
	{
	void ** list;
	int num;
	} HashItemList;

typedef struct
	{
	HashItemList * list;
	int num;
	int (*compare)(void *, void *);
	int (*hash)(void * obj);
	void (*free)(void *);
	int numObj;
	} HashTable;

typedef struct
  {
  HashTable * tab;
  int c1;
  int c2;
  } HashTableIterator;

void hash_create(HashTable * list, 
				 int size, 
				 int (*compare)(void *, void *),
				 int (*hash)(void *),
				 void (*freefunc)(void *));
void hash_insert(HashTable * list, void * item);
void * hash_get(HashTable * list, void * item);
void * hash_delete(HashTable * list, void * item);
void hash_destroy(HashTable * list);
int hash_string(char * s);
int hash_string_ignore_case(char * s);
int hash_buffer(char * s, int l);
void hash_reorganise(HashTable * list, int size);

#endif
